<?php
/**
 * Plugin spxwpolaroid
 *
 * @package SPX
 * @version	
 * @date	07/07/2014
 * @author	JE-EVRARD
 **/
class spxwpolaroid extends plxPlugin {
	
	
	/**
	 * Constructeur de la classe spxwslider
	 *
	 * @param	default_lang	langue par dfaut utilise par PluXml
	 * @return	null
	 * @author	
	 **/
	public function __construct($default_lang) {
		
		# Appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);
		
		# droits pour accder  la page config.php du plugin
		$this->initconfiguration();
		$this->setConfigProfil(PROFIL_ADMIN);
		$this->spxname="spxwpolaroid";

		# Dclarations des hooks
		if(!defined('PLX_ADMIN')) {
			$this->addHook('ThemeEndHead', 'addCssLibrairy');
			$this->addHook('ThemeEndBody', 'addJSlibrairy');
		}
		
		$this->addHook('spxwpolaroid::getPolaroidID', 'getUnsliderID');
		$this->addHook('spxwpolaroid::getPolaroidTitle', 'getUnsliderTitle');
	}

	public function initconfiguration() {
		# VARIOUS PARAMS
		$this->setParam('spxdatas_widget', '1', 'string');
		$this->setParam('spxshortcodes_shortcode', '1', 'string');
		
		if (plxUtils::strCheck($this->getParam('polaroidback'))=="") $this->setParam('polaroidback', '1', 'string');
		//if (plxUtils::strCheck($this->getParam('description'))=="") $this->setParam('description', '1', 'string');
		//if (plxUtils::strCheck($this->getParam('speed'))=="") $this->setParam('speed', '500', 'numeric');
		if (plxUtils::strCheck($this->getParam('dataformat'))=="") $this->setParam('dataformat', 'xml', 'string');
		
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmin'.$key))=="") $this->setParam('profiladmin'.$key,$this->get_adminright_list(),'string');
			
		}
		foreach($aProfils as $key=>$val) { 
			if (plxUtils::strCheck($this->getParam('profiladmincontent'.$key))=="") $this->setParam('profiladmincontent'.$key,$this->get_adminrightcontent_list(),'string');
		}
		
	}
	/**
	 * Mthode qui ajoute le fichier css 
	 *
	 * @return	stdio
	 * @author	Evrard jerome
	 **/
	
	public function addCssLibrairy() {
		
		// <link rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxwpolaroid/css/normalize.css" />
		//<link rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxwpolaroid/css/site.css" />
		echo "\n".'
		
		
		
		<link rel="stylesheet" type="text/css" href="'.PLX_PLUGINS.'spxwpolaroid/css/component.css" />
		
		<script src="'.PLX_PLUGINS.'spxwpolaroid/assets/modernizr.min.js"></script>
		';
	
	}
	/**
	 * Mthode qui ajoute les lib et init
	 *
	 * @return	
	 * @author	Evrard jerome
	 **/
	public function addJSlibrairy() {
		
		echo "\n".'
		

		<!-- Include required JS files -->
		<script type="text/javascript" src="'.PLX_PLUGINS.'spxwpolaroid/assets/classie.js"></script>		
		<script type="text/javascript" src="'.PLX_PLUGINS.'spxwpolaroid/assets/photostack.js"></script>
		
		<!--|--------------------------------------------------------------------------
		| POLAROID
		|---------------------------------------------------------------------------->
		
		<script type="text/javascript">
		
		
		';
		
			$plxMotor = plxMotor::getInstance();
			$o= array();
			$o["table"]="spxwpolaroids";
			$o["out"]="array";
			$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
			$tmp2 = $tmp->getData($o);
			foreach($tmp2 as $key=>$val) {
			
			
			
				echo "\n".'
				
			
				 if (document.getElementById("photostack-'.$val["spxwpolaroids_id"].'") != null ) {
					console.log("div exist");
					
					new Photostack( document.getElementById( "photostack-'.$val["spxwpolaroids_id"].'" ), {
						callback : function( item ) {
							//console.log(item)
						}
					} );
					
					
				 }
				
				
					
				';
			}
			
			
		echo "\n".'	
			</script>';
	}
	
	/**
	 * Mthode qui retourne les profils utilisateurs
	 *
	 * @return	// foreach($aProfils as $key=>$val) {
	 * @author	
	 **/
	
	public function get_aprofil() {
		# Tableau des profils
		return array(
			PROFIL_ADMIN => L_PROFIL_ADMIN,
			PROFIL_MANAGER => L_PROFIL_MANAGER,
			PROFIL_MODERATOR => L_PROFIL_MODERATOR,
			PROFIL_EDITOR => L_PROFIL_EDITOR,
			PROFIL_WRITER => L_PROFIL_WRITER
		);
		
	}
	
	# define admin right list for sliders list
	public function get_adminright_list() {
		return "view create modify delete";
	}
	
	# define admin right list for slider content
	public function get_adminrightcontent_list() {
		return "create modify delete";
	}
	
	public function get_tableuserlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			foreach($aright as $key2=>$val2) {
				if ($val2=="view"){
					$s.=$key.',';
					break;	
				}
			}
		}
		return substr ($s, 0, -1);
	}
	
	public function get_rightCMDlevel($param='profiladmin') {
		$s='';
		$aProfils = $this->get_aprofil();
		foreach($aProfils as $key=>$val) {
			$sright = $this->getParam($param.$key);
			$aright = explode (" ", $sright);
			$create='0';
			$modify='0';
			$delete='0';
			foreach($aright as $key2=>$val2) {
				if ($val2=="create"){
					$create='1';
				}
				if ($val2=="modify"){
					$modify='1';
				}
				if ($val2=="delete"){
					$delete='1';
				}
			}
			$s.=$key.':'.$create.$modify.$delete.',';
		}
		return substr ($s, 0, -1);
		//return '3:010,4:010';
	}
	
	public function write_table() {
		$xml =$this->get_table_spxdatas();
		$path = PLX_PLUGINS.'spxwpolaroid/spxdatas/table/table.php';
		$bwrite = plxUtils::write($xml,$path);
		/*
		if($bwrite) {
			return plxMsg::Info(L_SAVE_SUCCESSFUL);		
		} else {
			return plxMsg::Error(L_SAVE_ERR.' '.PLX_ROOT.$this->aConf['categories']);
		}
		*/
	}
	
	# get html content for slider
	public function getUnsliderID($id='001') {
		$filter = 'spxwpolaroids_id='.$id;
		$s='';
		$s.= $this->get_polaroid_request($filter);	
		return $s;
	}
	
	# get html content for slider
	public function getUnsliderTitle($name) {
		$filter = 'title='.$name;
		$s.= $this->get_polaroid_request($filter);		
		return $s;
	}
	
	public function get_polaroid_request($filter) {
		$plxMotor = plxMotor::getInstance();
		
		//$IMAGEPATH = plxUtils::getRacine().$plxMotor->aConf['images'];
		//if ($plxMotor->aConf['medias']) $IMAGEPATH = plxUtils::getRacine().$plxMotor->aConf['medias'];
		
		$IMAGEPATH = isset($plxMotor->aConf['medias']) ? plxUtils::getRacine().$plxMotor->aConf['medias'] : plxUtils::getRacine().$plxMotor->aConf['images'];		
		
		//echo ("test2=".$IMAGEPATH);
		
		$o= array();
		$o["table"]="spxwpolaroids";
		$o["format"]='#polaroid_content';
		$o["filter"]=$filter;
		$o["subtable_format"]["polaroid_content"]=$s;
		$tmp = $plxMotor->plxPlugins->aPlugins["spxdatas"];
		
		$o["out"]="array";
		$tmp2 = $tmp->getData($o);
		
		/*echo ("<pre>");
		print_r($tmp2);
		echo ("</pre>");*/
		$s='';
		$s.='<section id="photostack-'.$tmp2[0]["spxwpolaroids_id"].'" class="spxwpolaroid photostack photostack-start">';
		$s.='<div>';
			if (count($tmp2)==0) return $s;
			foreach($tmp2[0]["polaroid_content"] as $key=>$val) {
				if ($val["dummy"]=='1'){
					$s.='<figure data-dummy>';
				}else{
					$s.='<figure>';
				}
				$target='';
				if ($val['bt_blank'] =='1')
					$target = 'target="_blank"';
				
				
				if ($val['bt_lightbox'] =='1') {
					$s.='<a data-spxlighbox="true" href="'.$IMAGEPATH.$val["image"].'" class="photostack-img" ><img src="'.$IMAGEPATH.$val["image"].'" alt=""/></a>';
				}else{
					$s.='<a '.$target.' href="'.$val["bt_url"].'" class="photostack-img"><img src="'.$IMAGEPATH.$val["image"].'" alt=""/></a>';
				}
				
				$s.='
				<figcaption>
					<h2 class="photostack-title">'.$val["title"].'</h2>';
						if ($this->getParam('polaroidback')=="1"){
							if ($val["polaroidback"] !="" || $val["polaroidback"]=!"<p></p>"){
								$s.='<div class="photostack-back">
									<p>'.$val["polaroidback"].'</p>
								</div>';
							}
						}
				$s.='</figcaption>
				</figure>';
			}
		
		$s.='</div>';
		$s.='</section>';
		return $s;
		
	}
	
	# define admin right list
	public function get_table_spxdatas() {
		$dataformat='';
		if ($this->getParam('dataformat') =="json")
			$dataformat='dataformat="json"';
		$s='';
		$s.='<table name="spxwpolaroids" maxparam="2" groupe="spxwpolaroid" '.$dataformat.' tableuserlevel="'.$this->get_tableuserlevel().'" rightCMDlevel="'.$this->get_rightCMDlevel().'" >';
		$s.='<description><![CDATA[<p>List of polaroid</p>]]></description>';
			$s.='<column>';
					$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
					$s.='<parameter  name="polaroid_content" type="cdata" option="subtable/spxwpolaroid" ></parameter>';
			$s.='</column>';
		$s.='</table>';
		
		
		$s.='<table name="spxwpolaroid" maxparam="3" groupe="spxwpolaroid" type="subtable" order="true" '.$dataformat.' rightCMDlevel="'.$this->get_rightCMDlevel('profiladmincontent').'" >';
		$s.='<description><![CDATA[<p>Your polaroid</p>]]></description>';
			$s.='<column>';
				
				$s.='<parameter  name="title" type="cdata" option="textinput/30/100" ></parameter>';
				$s.='<parameter  name="image" type="cdata" option="image" ></parameter>';
				$s.='<parameter name="dummy" type="string" option="checkboxBoolean"></parameter>';
				//if ($this->getParam('polaroidback') =='1')
				$s.='<parameter  name="bt_url" type="cdata" option="textinput/30/100" ></parameter>';
				$s.='<parameter name="bt_blank" type="string" option="checkboxBoolean"></parameter>';
				$s.='<parameter name="bt_lightbox" type="string" option="checkboxBoolean"></parameter>';
				$s.='<parameter  name="polaroidback" type="cdata" option="textarea/40/10" ></parameter>';
				
			$s.='</column>';
		$s.='</table>';
		return $s;
	}
	
	# getloc call by spxdatas
	public function get_loc($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
	}
	
	# getdefaultloc use by config traduction
	public function get_loc_default($mylang) {
		$filename = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin_default.php';
		
		$LANG = array();
		if(is_file($filename)) {
			include($filename);
		}
		return $LANG;
		
	}
	
	# record loc for spxdatas
	public function set_loc($mylang) {
		$atraddefault = $this->get_loc_default($mylang);
		$LANG="LANG";
		$out="<?php
		
					$$LANG = array(";
		foreach($atraddefault as $key=>$val) {
			
			$code = 'admin_loc_'.$trad.'_'.$key;
			$check = $this->getParam($code);
			if ($check=="-") {
				$loc="";
			}else if ($check=="") {
				$loc=$val;
			}else{
				$loc=$check;
			}
			$loc = str_replace("'", "\'", $loc);
			
			$out.="'".$key."'			=> '".$loc."',";
		}
		$out.="	
					);
					?>";
		$fileloc = PLX_PLUGINS.$this->spxname.'/spxdatas/table/table_loc/'.$mylang.'/admin.php';
		plxUtils::write($out,$fileloc);
	}

}

?>